/*******************************************************************************
 * Copyright (c) 2009 Information-technology Promotion Agency, Japan.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
package benten.cat.glossary.ui;

import org.eclipse.core.runtime.preferences.AbstractPreferenceInitializer;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.preference.PreferencePage;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

import benten.cat.glossary.core.CatGlossaryCorePlugin;

public class CatGlossaryUiPreferencePage extends PreferencePage implements IWorkbenchPreferencePage {

	public static String CREATOR = "CREATOR";
	private Text creator;

	public CatGlossaryUiPreferencePage() {
	}

	public CatGlossaryUiPreferencePage(String title) {
		super(title);
	}

	public CatGlossaryUiPreferencePage(String title, ImageDescriptor image) {
		super(title, image);
	}

	@Override
	protected Control createContents(Composite parent) {
		Composite composite = new Composite(parent, SWT.NONE);
		GridLayout layout = new GridLayout();
		layout.numColumns = 2;
		composite.setLayout(layout);
		composite.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));

		Label labal = new Label(composite, SWT.NONE);
		labal.setText("作成者:");

		creator = new Text(composite, SWT.SINGLE | SWT.BORDER);
		creator.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));
		IPreferenceStore sotre = CatGlossaryCorePlugin.getDefault().getPreferenceStore();
		creator.setText(sotre.getString(CREATOR));
		return composite;
	}

	public void init(IWorkbench workbench) {
	}

	@Override
	public boolean performOk() {
		IPreferenceStore store = CatGlossaryCorePlugin.getDefault().getPreferenceStore();
		store.setValue(CREATOR, creator.getText());
		return true;
	}

	@Override
	protected void performDefaults() {
		IPreferenceStore store = CatGlossaryCorePlugin.getDefault().getPreferenceStore();
		creator.setText(store.getDefaultString(CREATOR));
	}

	public static class Initializer extends AbstractPreferenceInitializer {
		@Override
		public void initializeDefaultPreferences() {
			IPreferenceStore store = CatGlossaryCorePlugin.getDefault().getPreferenceStore();
			store.setDefault(CREATOR, "");
		}
	}
}
